//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39A3E244033C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39A3E244033C.cm

//## begin module%39A3E244033C.cp preserve=no
//## end module%39A3E244033C.cp

//## Module: EinsteinIO%39A3E244033C; Package specification
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/DataFactory/EinsteinIO.h

#ifndef EINSTEINIO_H
#define EINSTEINIO_H 1

//## begin module%39A3E244033C.additionalIncludes preserve=no
//## end module%39A3E244033C.additionalIncludes

//## begin module%39A3E244033C.includes preserve=yes
#include "XspecDataIO.h"
//## end module%39A3E244033C.includes

//## begin module%39A3E244033C.declarations preserve=no
//## end module%39A3E244033C.declarations

//## begin module%39A3E244033C.additionalDeclarations preserve=yes
namespace CCfits
{
        class FITS;
        class ExtHDU;       
}
//## end module%39A3E244033C.additionalDeclarations


//## begin EinsteinIO%39A3E3150250.preface preserve=yes
//## end EinsteinIO%39A3E3150250.preface

//## Class: EinsteinIO%39A3E3150250
//	See XspecDataIO for details.
//## Category: XSModel::DataFactory%399415D40147
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3AAD01B60242;CCfits::ExtHDU { -> F}

class EinsteinIO : public XspecDataIO  //## Inherits: <unnamed>%3AACF9920105
{
  //## begin EinsteinIO%39A3E3150250.initialDeclarations preserve=yes
  //## end EinsteinIO%39A3E3150250.initialDeclarations

  public:
    //## Destructor (generated)
      virtual ~EinsteinIO();


    //## Other Operations (specified)
      //## Operation: write%39A3E42A0096
      virtual void write (const string& fileName);

      //## Operation: read%39A3E426001D
      virtual size_t read (const string& fileName, bool readFlag = true);

      //## Operation: fileFormat%39AD452F0392
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

    // Additional Public Declarations
      //## begin EinsteinIO%39A3E3150250.public preserve=yes
      //## end EinsteinIO%39A3E3150250.public

  protected:
    //## Constructors (generated)
      EinsteinIO();

      EinsteinIO(const EinsteinIO &right);


    //## Other Operations (specified)
      //## Operation: channelBounds%39FDAD42002E
      virtual void channelBounds (int& startChannel, int& endChannel, size_t row = 0) const;

      //## Operation: closeFile%3A3941A7019B
      void closeFile ();

      //## Operation: swap%3A95797C00B2
      virtual void swap (EinsteinIO& right);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::DataFactory::<unnamed>%3AAD007C02CD
      //## Role: EinsteinIO::dataSource%3AAD007D0209
      const CCfits::FITS* dataSource () const;
      void dataSource (CCfits::FITS* value);

    // Additional Protected Declarations
      //## begin EinsteinIO%39A3E3150250.protected preserve=yes
      //## end EinsteinIO%39A3E3150250.protected

  private:
    //## Assignment Operation (generated)
      EinsteinIO & operator=(const EinsteinIO &right);

    // Additional Private Declarations
      //## begin EinsteinIO%39A3E3150250.private preserve=yes
      //## end EinsteinIO%39A3E3150250.private

  private: //## implementation
    // Data Members for Associations

      //## Association: XSModel::DataFactory::<unnamed>%3AAD007C02CD
      //## begin EinsteinIO::dataSource%3AAD007D0209.role preserve=no  protected: CCfits::FITS { -> 1RFHgN}
      CCfits::FITS* m_dataSource;
      //## end EinsteinIO::dataSource%3AAD007D0209.role

    // Additional Implementation Declarations
      //## begin EinsteinIO%39A3E3150250.implementation preserve=yes
      //## end EinsteinIO%39A3E3150250.implementation

};

//## begin EinsteinIO%39A3E3150250.postscript preserve=yes
//## end EinsteinIO%39A3E3150250.postscript

// Class EinsteinIO 

//## Get and Set Operations for Associations (inline)

inline const CCfits::FITS* EinsteinIO::dataSource () const
{
  //## begin EinsteinIO::dataSource%3AAD007D0209.get preserve=no
  return m_dataSource;
  //## end EinsteinIO::dataSource%3AAD007D0209.get
}

inline void EinsteinIO::dataSource (CCfits::FITS* value)
{
  //## begin EinsteinIO::dataSource%3AAD007D0209.set preserve=no
  m_dataSource = value;
  //## end EinsteinIO::dataSource%3AAD007D0209.set
}

//## begin module%39A3E244033C.epilog preserve=yes
//## end module%39A3E244033C.epilog


#endif
